<?php
/*
Filename: 		rxpcur-ajax.php
Date: 			2008-08-27
Copyright: 		2008, Reality XP
Author: 		Reality XP
Description: 	PHP Back-end to fetch Currency Conversion Rates from Yahoo! Finance. 
License:		GPL
Inspired by:	http://www.talkphp.com/general/1422-creating-simple-currency-converter-automatic-symbols.html
				http://chaos-laboratory.com/2007/03/01/currex-ajax-based-currency-converter-widget-for-wordpress/
*/

// Exit if no function specified
if( !isset( $_POST['action'] ) || '' == $_POST['action'] ) {
	echo '{ errcode: "ERR-000", errmsg: "No action specified" }';
	exit();
}

switch ($_POST['action']) {
	
	case 'rate':
		$currfrom = $_POST['currfrom'];
		$currto = $_POST['currto'];
		$conversion_rate = get_conversion_rate( $currfrom, $currto );
			
		if( $conversion_rate != false ) {
			$result = $conversion_rate * 1.0;
			echo '{ errcode: "ERR-100", errmsg: "Conversion Successful", result: "' . $result . '" }';
			exit();
		}
		else {
			echo '{ errcode: "ERR-200", errmsg: "Error contacting Yahoo! Finance" }';
			exit();
		}
		break;
		
	default:
		echo '{ errcode: "ERR-210", errmsg: "Unknown conversion error" }';
		exit();
}

function get_conversion_rate( $cur_from, $cur_to ) {

	if( strlen( $cur_from ) == 0 )
		$cur_from = "USD";

	if( strlen( $cur_to ) == 0 )
		$cur_to = "USD";

	if ($cur_from == $cur_to)
		return "1.0";
				
	$data = "";
	$host = "download.finance.yahoo.com";
	$fp = @fsockopen( $host, 80, $errno, $errstr, 30 );
	if ( !$fp ) {
		$errorstr = "$errstr ($errno)<br />\n";
		return false;
	}
	else {
		// Build Query String
		// Query URL: http://download.finance.yahoo.com/d/quotes.csv?s=[$cur_from][$cur_to]=X&f=l1
		// Returns: A Plain Text file which contains the current exchange rate
		// Example content: 32.15
		//					The source and destination currencies used here
		//					were USD (US Dollar) and GBP (Great Britain Pound)
		$file = "/d/quotes.csv";
		$str = "?s=" . $cur_from . $cur_to . "=X&f=l1";
		$out = "GET " . $file . $str . " HTTP/1.0\r\n";
	    $out .= "Host: www.yahoo.com\r\n";
		$out .= "Connection: Close\r\n\r\n";
		
		@fputs( $fp, $out );
		while( !@feof( $fp ) )
			$data .= @fgets( $fp, 128 );
		@fclose( $fp );

		@preg_match( "/^(.*?)\r?\n\r?\n(.*)/s", $data, $match );
		$data = $match[2];
		return $data;
	}//else
}//end get_conversion
	
?>